> For the complete documentation index, see [llms.txt](https://docs.zama.org/concrete/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zama.org/concrete/execution-analysis/summary.md).

# Performance

This document shows some basic things you can do to improve the performance of your circuit.

Here are some quick tips to reduce the execution time of your circuit:

* Reduce the amount of [table lookups](/concrete/operations/table_lookups.md) in the circuit.
* Try different implementation strategies for [complex operations](/concrete/operations/non_linear_operations.md#comparisons).
* Utilize [rounding](/concrete/explanations/advanced-features/rounding.md) and [truncating](/concrete/explanations/advanced-features/truncating.md) if your application doesn't require precise execution.
* Use tensors as much as possible in your circuits.
* Enable dataflow parallelization, by setting `dataflow_parallelize=True` in the [configuration](/concrete/guides/configure.md).
* Tweak `p_error` configuration option until you get optimal exactness vs performance tradeoff for your application.
* Specify composition when using [modules](/concrete/compilation/combining/composing_functions_with_modules.md#optimizing-runtimes-with-composition-policies).

You can refer to our full [Optimization Guide](/concrete/guides/self.md) for detailed examples of how to do each of these, and more!


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.zama.org/concrete/execution-analysis/summary.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
